#define BLYNK_PRINT SerialUSB
#include <Adafruit_CircuitPlayground.h>
#include <ESP8266_Lib.h>
#include <BlynkSimpleShieldEsp8266.h>

char auth[] = "MfB7F4pqcpyRrv0dKzjTbu9e-7fqxiLj";
char ssid[] = "Dangoor 2.4 ";
char pass[] = "12345678";

#define EspSerial Serial1
#define ESP8266_BAUD 9600
ESP8266 wifi(&EspSerial);

 /********************************* Setup initial thresholds ***********************************************/
#define cap_threshold 700
#define light_threshold 200

void setup() {
  CircuitPlayground.begin();
  SerialUSB.begin(9600);
  EspSerial.begin(ESP8266_BAUD);
  delay(10);
  Blynk.begin(auth, wifi, ssid, pass);
}
// Red laert animation when more water is needed
BLYNK_WRITE(V3) {
  if (param[0]) {
    for (int j = 0; j < 3; j++) {
      for (int i = 0; i < 12; i++) {
        CircuitPlayground.setPixelColor(i , 255,   0,   0);
        CircuitPlayground.setPixelColor(i - 2 , 0,   0,   0);
        delay(25);
      }
    }
  }
}
// noise alert for irregular temprature
BLYNK_WRITE(V4) {
  if (param[0]) {
    CircuitPlayground.playTone(262, 100, false);
    CircuitPlayground.playTone(262, 100, false);
    CircuitPlayground.playTone(262, 100, false);
    delay(45);
    CircuitPlayground.playTone(262, 100, false);
    CircuitPlayground.playTone(262, 100, false);
    CircuitPlayground.playTone(262, 100, false);
    delay(45);
    CircuitPlayground.playTone(262, 100, false);
    CircuitPlayground.playTone(262, 100, false);
    CircuitPlayground.playTone(262, 100, false);
  }
}

void loop() {
  Blynk.run();

  /********************************* M O I S T ***********************************************/
  // get moist value
  int moistValue = CircuitPlayground.readCap(A1);
  delay(50);
  //Serial.println(moistValue);

  //send moist data to blynk
  Blynk.virtualWrite(V0, moistValue);

  if (moistValue < cap_threshold) {
    WidgetLCD lcd(V3);
    lcd.print(0, 0, "NEEDS MORE WATER");
    //CircuitPlayground.playTone(262, 100, false);
  }
  else {
    WidgetLCD lcd(V3);
    lcd.print(0, 0, "ENOUGH WATER    ");
  }

  /********************************* L I G H T ***********************************************/
  // send current light to blynk
  float currentLight = CircuitPlayground.lightSensor();
  Blynk.virtualWrite(V1, currentLight);

  // when not enoguh light
  if (currentLight < light_threshold) {
    //Serial.println(currentLight);
    WidgetLCD lcd(V3);
    lcd.print(0, 1, "NEEDS MORE LIGHT");
  }  else {
    WidgetLCD lcd(V3);
    lcd.print(0, 1, "ENOUGH LIGHT    ");
  }

  /********************************* T E M P R A T U R E ***********************************************/
  float temprature = CircuitPlayground.temperature();
  Serial.println(temprature);
  Blynk.virtualWrite(V2, temprature);

}
